diff --git a/include/ua_plugin_nodestore.h b/include/ua_plugin_nodestore.h
index 693428e0062..403374e96c0 100644
--- a/include/ua_plugin_nodestore.h
+++ b/include/ua_plugin_nodestore.h
@@ -94,6 +94,10 @@ UA_StatusCode UA_EXPORT
 UA_Node_setAttributes(UA_Node *node, const void *attributes,
                       const UA_DataType *attributeType);
 
+/* Copy the references from one array to another */
+UA_StatusCode UA_EXPORT
+UA_NodeReferenceKind_copy(const UA_NodeReferenceKind *src, size_t srcSize, UA_NodeReferenceKind **dst);
+
 /* Reset the destination node and copy the content of the source */
 UA_StatusCode UA_EXPORT
 UA_Node_copy(const UA_Node *src, UA_Node *dst);
diff --git a/src/server/ua_nodes.c b/src/server/ua_nodes.c
index 361925f9600..b75e8d1d52a 100644
--- a/src/server/ua_nodes.c
+++ b/src/server/ua_nodes.c
@@ -133,6 +133,40 @@ UA_ViewNode_copy(const UA_ViewNode *src, UA_ViewNode *dst) {
     return UA_STATUSCODE_GOOD;
 }
 
+UA_StatusCode
+UA_NodeReferenceKind_copy(const UA_NodeReferenceKind *src, const size_t srcSize, UA_NodeReferenceKind **dst) {
+    *dst = NULL;
+    if(srcSize > 0) {
+        *dst = (UA_NodeReferenceKind*)
+                UA_calloc(srcSize, sizeof(UA_NodeReferenceKind));
+        if(!*dst) {
+            return UA_STATUSCODE_BADOUTOFMEMORY;
+        }
+
+        UA_StatusCode retval;
+        for(size_t i = 0; i < srcSize; ++i) {
+            const UA_NodeReferenceKind *srefs = &src[i];
+            UA_NodeReferenceKind *drefs = &(*dst)[i];
+            drefs->isInverse = srefs->isInverse;
+            retval = UA_NodeId_copy(&srefs->referenceTypeId, &drefs->referenceTypeId);
+            if(retval != UA_STATUSCODE_GOOD)
+                break;
+            retval = UA_Array_copy(srefs->targetIds, srefs->targetIdsSize,
+                                   (void**)&drefs->targetIds,
+                                   &UA_TYPES[UA_TYPES_EXPANDEDNODEID]);
+            if(retval != UA_STATUSCODE_GOOD)
+                break;
+            drefs->targetIdsSize = srefs->targetIdsSize;
+        }
+        if(retval != UA_STATUSCODE_GOOD) {
+            UA_free(*dst);
+            *dst = NULL;
+            return retval;
+        }
+    }
+    return UA_STATUSCODE_GOOD;
+}
+
 UA_StatusCode
 UA_Node_copy(const UA_Node *src, UA_Node *dst) {
     if(src->nodeClass != dst->nodeClass)
@@ -152,34 +186,10 @@ UA_Node_copy(const UA_Node *src, UA_Node *dst) {
     }
 
     /* Copy the references */
-    dst->references = NULL;
-    if(src->referencesSize > 0) {
-        dst->references = (UA_NodeReferenceKind*)
-            UA_calloc(src->referencesSize, sizeof(UA_NodeReferenceKind));
-        if(!dst->references) {
-            UA_Node_deleteMembers(dst);
-            return UA_STATUSCODE_BADOUTOFMEMORY;
-        }
-        dst->referencesSize = src->referencesSize;
-
-        for(size_t i = 0; i < src->referencesSize; ++i) {
-            UA_NodeReferenceKind *srefs = &src->references[i];
-            UA_NodeReferenceKind *drefs = &dst->references[i];
-            drefs->isInverse = srefs->isInverse;
-            retval = UA_NodeId_copy(&srefs->referenceTypeId, &drefs->referenceTypeId);
-            if(retval != UA_STATUSCODE_GOOD)
-                break;
-            retval = UA_Array_copy(srefs->targetIds, srefs->targetIdsSize,
-                                    (void**)&drefs->targetIds,
-                                    &UA_TYPES[UA_TYPES_EXPANDEDNODEID]);
-            if(retval != UA_STATUSCODE_GOOD)
-                break;
-            drefs->targetIdsSize = srefs->targetIdsSize;
-        }
-        if(retval != UA_STATUSCODE_GOOD) {
-            UA_Node_deleteMembers(dst);
-            return retval;
-        }
+    retval = UA_NodeReferenceKind_copy(src->references, src->referencesSize, &dst->references);
+    if (retval != UA_STATUSCODE_GOOD) {
+        UA_Node_deleteMembers(dst);
+        return retval;
     }
 
     /* Copy unique content of the nodeclass */
diff --git a/src/server/ua_server.c b/src/server/ua_server.c
index 2d5b664e5ab..46c639b6c89 100644
--- a/src/server/ua_server.c
+++ b/src/server/ua_server.c
@@ -58,23 +58,22 @@ UA_Server_forEachChildNodeCall(UA_Server *server, UA_NodeId parentNodeId,
      * delete references from within the callback. In single-threaded mode this
      * changes the same node we point at here. In multi-threaded mode, this
      * creates a new copy as nodes are truly immutable. */
-    UA_ReferenceNode *refs = NULL;
-    size_t refssize = parent->referencesSize;
-    UA_StatusCode retval = UA_Array_copy(parent->references, parent->referencesSize,
-        (void**)&refs, &UA_TYPES[UA_TYPES_REFERENCENODE]);
+	UA_NodeReferenceKind *refs = NULL;
+	UA_StatusCode retval = UA_NodeReferenceKind_copy(parent->references, parent->referencesSize, &refs);
     if(retval != UA_STATUSCODE_GOOD) {
         server->config.nodestore.releaseNode(server->config.nodestore.context, parent);
         return retval;
     }
 
     for(size_t i = parent->referencesSize; i > 0; --i) {
-        UA_ReferenceNode *ref = &refs[i - 1];
-        retval |= callback(ref->targetId.nodeId, ref->isInverse,
+		UA_NodeReferenceKind *ref = &refs[i - 1];
+		for (size_t j = 0; j<ref->targetIdsSize; j++)
+        	retval |= callback(ref->targetIds[j].nodeId, ref->isInverse,
                            ref->referenceTypeId, handle);
     }
 
     server->config.nodestore.releaseNode(server->config.nodestore.context, parent);
-    UA_Array_delete(refs, refssize, &UA_TYPES[UA_TYPES_REFERENCENODE]);
+    UA_free(refs);
     return retval;
 }
 
